
// urDoPageChange
// monitors content window updates
function urDoPageChange(addy) {
	debugDump("\n\n--urDPC \n");
  lastLoc = document.getElementById("heuristic_url").getAttribute("url");
  lastTitle =  browserHandle.contentDocument.title; // Add DOMContentLoaded listener for notification when title is loaded
  lastLoc = curLoc;
	curLoc = addy;
	//curTitle = aLocation.document.title;
  debugDump("Got aLocation " + curLoc + "\n");
  debugDump("--urDPC---------------\nFrom " + lastLoc + "\n to " + curLoc + " \n");
	debugDump("-- From Title: " + lastTitle + "\n");
  // If we have a heuristic on the last page, update this.
	debugDump("Heuristics logged? " + heuristicsLoggedOnPage + "\n");
	// Log previous page
	if(!uzInKeyword) {
	  if(heuristicsLoggedOnPage) { 
	    debugDump("Invoking heuristic log \n");
	    logHeuristics(); // in heuristics_run.js
		} 
	} else {
		uzLogKeywordPage(uzInKeyword);
	}
  document.getElementById("heuristic_url").value= trimUrl(curLoc); 
	document.getElementById("heuristic_url").setAttribute("url", curLoc);  
  document.getElementById("heuristic_url").setAttribute("tooltiptext", curLoc);
	
	uzLoadExisting();
}



function uzLoadExisting() {
	// Reset current focus due to page change
	uzCurPageNode = false;
	uzCurKeywordNode = false;
	var nodes, node; // XPath results
	var curFocusXML;
	var expression;
	
	if(uzInKeyword) {
		xexpression = "//keyword[@id=\"" + uzInKeyword + "\"]"; 
		
		debugDump("New " + xexpression + "\n");
	} else {
		xexpression = "//page[@url=\"" + curLoc + "\"]";
		debugDump("New " + xexpression + "\n");

	}

	nodes = xHeuristics.evaluate(xexpression, xHeuristics, null, 0, null);  // Xpath eval
	debugDump(">> uzReview: Pre-existing content for this page/keyword (" + uzInKeyword + ") " + nodes + "\n");
	node = nodes.iterateNext();
	debugDump("Got node " + node + "\n");
	if(node) {
		
		if(uzInKeyword) {
			debugDump("Page exists in keyword \n");
			uzCurKeywordNode = node;
			
			
		} else {
			// Just a page revisit
			debugDump("Page exists in page \n");
			uzCurPageNode = node;
		}
		debugDump("trying to load from pre-existing page node \n");
		uzLoadHeuristicsFromXML(node);
	}
	return node;
}

// Populates form with saved heuristic
// Takes a node to populate from.
function uzLoadHeuristicsFromXML(node) {
	var ratingWidgetIndex;
	var heuristicNode;
	var ratingXMLValue;
	var commentNode;
	var heuristics = node.getElementsByTagName("heuristic");
	debugDump("found " + heuristics + " of " + heuristics.length + "\n");
	if(!heuristics.length) {
		deleteAllChilds(document.getElementById("heuristic-holder"));
		populateHeuristicsForm(heuristicsXML);
	}
	for(var i=0;i<heuristics.length;i++) {
		debugDump("Looking for " + heuristics.item(i).getAttribute("id") + " and finding...\n");
		heuristicNode = document.getElementById(heuristics.item(i).getAttribute("id")).parentNode;
		//debugDump("Got ui " + heuristicNode + "  of " + heuristicNode.nodeName + "\n", "load");
		//debugDump("Got value " + heuristics.item(i).getAttribute("value") + "\n","load");
		ratingXMLValue = heuristics.item(i).getAttribute("value")
		switch (heuristics.item(i).getAttribute("value")) {
			case "1": ratingWidgetIndex = 0;break;
			case "-1":ratingWidgetIndex = 2;break;
			case "-2":ratingWidgetIndex=3;break;
			case "-3":ratingWidgetIndex=4;break;
			case "-4":ratingWidgetIndex=5;break;
			case "-5":ratingWidgetIndex=6;break;
		}
		debugDump("sedond child is " + heuristicNode.childNodes.item(2).nodeName + "\n");
		// Set rating widget
		debugDump("rating widget default is "  + heuristicNode.childNodes.item(2).selectedIndex + "\n");
		heuristicNode.childNodes.item(2).selectedIndex = ratingWidgetIndex;
		commentNode = makeCommentBlock(heuristicNode.parentNode);
		// Populate comment box if content (#text nodes as child of heuristic)
		if(heuristics.item(i).childNodes.length) commentNode.value = heuristics.item(i).firstChild.nodeValue;
		
	}
	heuristicsLoggedOnPage = true;
}

// Called on page load or keyword change
// to create an xml doc from the current 
// heuristics UI.
// Returns string of heuristic elements enclosed by the currentpage.
function extractHeuristicsPage() {

  formRoot = document.getElementById("heuristic-holder");
	debugDump("\n*** Saving heuristics (" + formRoot.childNodes.length +") ***\n");
  var heuristicMeasure, heuristicComment, heuristicID, logThisHeuristic;
  var tempXMLString, xmlRoot;
  debugDump("Cur page is " +  document.getElementById("heuristic_url").getAttribute("url") + "\n");
  
  tempXMLString = '<page url="' + xmlEscape(document.getElementById("heuristic_url").getAttribute("url")) + '" ';
  tempXMLString += 'title="' + xmlEscape(lastTitle) + '"';
	tempXMLString += '>';
	debugDump("looping " + formRoot.childNodes.item(0).nodeName + "\n");
 	tempXMLString += extractHeuristicsReviews();
  tempXMLString += "</page>";  
  debugDump("\n\n XML is " + tempXMLString + "\n");
  return tempXMLString;
}

function extractHeuristicsKeyword() {
  formRoot = document.getElementById("heuristic-holder");
	debugDump("\n*** Saving heuristics (" + formRoot.childNodes.length +") ***\n");
  var heuristicMeasure, heuristicComment, heuristicID, logThisHeuristic;
  var tempXMLString, xmlRoot;
  debugDump("Cur keyword is " +  document.getElementById("heuristic_keyword").value + "\n");
  // Need to deal with XML &,<,> in the id
  tempXMLString = '<keyword id="' + document.getElementById("heuristic_keyword").value + '" ';
	// This really shouldn't be here
	// But we should log an array of pages visited
	tempXMLString += ' title="' + xmlEscape(lastTitle) + '" ';
	tempXMLString += '>';
  //tempXMLString += 'title="' + xmlEscape(lastTitle) + '">';
	debugDump("looping " + formRoot.childNodes.item(0).nodeName + "\n");
 	tempXMLString += extractHeuristicsReviews();
  tempXMLString += "</keyword>";  
  debugDump("\n\n XML is " + tempXMLString + "\n");
  return tempXMLString;
}


function extractHeuristicsReviews() {
	var tempXMLString ='';
 	var formElementRoot;
 	var formRoot = document.getElementById("heuristic-holder");
 	for(var i=0;i<formRoot.childNodes.length;i++) {
    logThisHeuristic = false;
    formElementRoot = formRoot.childNodes.item(i);
    //debugDump(i + "commented? " + formElementRoot.getAttribute("comment") + " ", "extraction");
    if(formElementRoot.getAttribute("comment") == true && formElementRoot.childNodes.length > 0) debugDump("comment is " + formElementRoot.childNodes.item(1).nodeName + "\n");
    debugDump("name/id is" + formElementRoot.childNodes.item(0).childNodes.item(0).nodeName + "\n");
    
    heuristicMeasure = formElementRoot.childNodes.item(0).childNodes.item(2);
    //debugDump("menulist is " + formElementRoot.childNodes.item(0).childNodes.item(2).nodeName +  " with " + heuristicMeasure.selectedItem.value + "\n", "extraction");

    if(heuristicMeasure.selectedItem.value != 0  || (formElementRoot.getAttribute("comment") == true && formElementRoot.childNodes.length > 0 && formElementRoot.childNodes.item(1).value.length)) {
      logThisHeuristic = true;
      debugDump("Log this " + logThisHeuristic + " with comment " + formElementRoot.getAttribute("comment") + "\n");
      heuristicID = formElementRoot.childNodes.item(0).childNodes.item(0).getAttribute("id");
      if(formElementRoot.getAttribute("comment") == "true") {
        debugDump("comment node is " + formElementRoot.childNodes.item(1).nodeName + " with " + formElementRoot.childNodes.item(1).value + "\n");
        //debugDump("comment is " + formElementRoot.childNodes.item(1).value + "\n");
        heuristicComment = formElementRoot.childNodes.item(1).value;
      } else {
        heuristicComment = false;
      }
      if(logThisHeuristic) {
        debugDump("adding heur node \n");
        tempXMLString += '<heuristic id="' + heuristicID + '" value="';
        tempXMLString += heuristicMeasure.selectedItem.value + '" '
				tempXMLString +='>'
        if(heuristicComment) tempXMLString += xmlEscape(heuristicComment);
        tempXMLString += '</heuristic>';
      }
    }  
  }
	return tempXMLString;
}
/* 
Heuristic Template 

<vbox id="heuristic-template" comment="false" hidden="true"><hbox><text value="name" id="id"/><spacer flex="1"/><menulist selectedIndex="2" onchange="debugDump('Flag for log\n');heuristicsLoggedOnPage=true;"><menupopup><menuitem label="Yes"/><menuitem label="--" selected="true"/><menuitem label="No"/></menupopup></menulist><text value="+" onclick="makeCommentBlock(this.parentNode.parentNode)"/></hbox></vbox> 
*/

// Manages extracting and persisting reviews
// during identifier changes (url or keyword)  
// Saves review data to xHeuristics and resets
// the UI.
// Called from: 
function logHeuristics(){
	var heuristicString, reviewNode, tempXML;
	var keyword;
	debugDump(">>uzReview: logging in mode keyword? " + uzInKeyword + "\n");
	if(!uzInKeyword) {
		// DELETE ME
		if(document.getElementById("heuristic_keyword").value.length) {
			// Revised, this should never execute. Caught at toggle level.
			// Switched to page with keyword active
			// log keyword
			debugDump("XXXXX Got into out of keyword \n");
			//uzAddKeywordToMenu(uzInKeyword); // Takes care of duplicate checking
		}
		//let uzToggle take care of flag
		//uzInKeyword=false;
		heuristicString = extractHeuristicsPage();
		dump("new string is " + heuristicString + "\n");
		reviewNode = xHeuristics.getElementsByTagName("uzreviewdata").item(0);
		tempXML =  new DOMParser().parseFromString(heuristicString, "text/xml");
		if(!uzCurPageNode) {
			// New Page
		  debugDump("Logging & Repopulating heuristics\n");
		  debugDump(tempXML.childNodes.item(0).nodeName + "is first kid\n");
		  reviewNode.appendChild(tempXML.childNodes.item(0));
		  //dumpXML(xHeuristics); 
			//heuristicsLoggedOnPage = true; 
		} else {
			// Update node, not add new

		// Causing chokes on first page load?
		// Why?

		if(uzCurPageNode && tempXML &&  tempXML.childNodes.length) {
				debugDump("uzReview: Replaced old page node " + tempXML.childNodes.lenth + " with " + uzCurPageNode + "\n"); 
		
				reviewNode.replaceChild( tempXML.childNodes.item(0), uzCurPageNode);
		}
			// TODO ???, disabled 0.5.8a
			//heuristicsLoggedOnPage = true;
		}
		
	} else {
		keyword = document.getElementById("heuristic_keyword").value;
		debugDump("Need to commit keyword \n");
		//debugDump(uzInKeyword.typeOf() ) + " is type of \n");
		uzAddKeywordToMenu(keyword);
		// Get the heuristics out of the form into xml
		heuristicString = extractHeuristicsKeyword();
		dump("new string is " + heuristicString + "\n");
		// Make it an xml object
		tempXML =  new DOMParser().parseFromString(heuristicString, "text/xml");
		document.getElementById("heuristic_keyword").value ="";
		// TODO: Check to see if current keyword is in xHeuristics
		uzCurReviewNode = checkForKeywordInXML(keyword);
		reviewNode = xHeuristics.getElementsByTagName("uzreviewdata").item(0);
		debugDump("Add new keyword or replace? " + uzCurReviewNode + "\n");
		if(uzCurReviewNode) {
			reviewNode.replaceChild(tempXML.childNodes.item(0), uzCurReviewNode);
		} else {
			reviewNode.appendChild(tempXML.childNodes.item(0));
		}

	}
	deleteAllChilds(document.getElementById("heuristic-holder"));
	heuristicsLoggedOnPage = false;
	populateHeuristicsForm(heuristicsXML);
	
}

function checkForKeywordInXML(uzInKeyword) {
		// Load preexisting keyword
		xexpression = "//keyword[@id=\"" + uzInKeyword + "\"]";
		nodes = xHeuristics.evaluate(xexpression, xHeuristics, null, 0, null);  // Xpath eval
		debugDump(">> uzReview: Pre-existing content for this page/keyword " + nodes + "\n");
		node = nodes.iterateNext();
		debugDump("Got node " + node + "\n");
		if(node) {
			debugDump("Found keyword node existing\n");
		}
		return node; // NULL if no node found
}


// Repopulate form from loaded heuristics file
function populateHeuristicsForm(heuristicsForUI) {
  debugDump("Populating heuristics with " + heuristicsForUI + "\n");
  var heuristics = heuristicsForUI.getElementsByTagName("heuristic");
  debugDump("Got " + heuristics.length + " heuristics\n");
  var heurNode = document.getElementById("heuristic-template");
  // Hack to deal with problems cloning hidden element
  heurNode.setAttribute("hidden", false);
  var tempNode;
  for(var i=0;i<heuristics.length;i++) {    
    //debugDump(i + " " + heuristics.item(i).getAttribute("label") + " \n","load");
    tempNode = heurNode.cloneNode(true);
    tempNode.childNodes.item(0).childNodes.item(0).setAttribute("value", heuristics.item(i).getAttribute("label"));
		tempNode.childNodes.item(0).childNodes.item(2).setAttribute("built", "false");
		tempNode.childNodes.item(0).childNodes.item(2).setAttribute("open", "false");
    //alert("value cloned.");
    tempNode.childNodes.item(0).childNodes.item(0).setAttribute("id", heuristics.item(i).getAttribute("id"));
    document.getElementById("heuristic-holder").appendChild(tempNode);  
  }
  heurNode.setAttribute("hidden", true);
}

// Keep the menudrop down for keyword uptodate
function uzAddKeywordToMenu(keyword) {  
	var preExisting = false;
	var tempNode;
	for(var i in uzKeywords) {
		if(i==keyword) preExisting=true;
	}
	if(!preExisting) {
		tempNode = document.createElement("menuitem");
		tempNode.setAttribute("label", keyword);
		document.getElementById("heuristic_keyword").childNodes.item(0).appendChild(tempNode);
	}
	uzKeywords[keyword] = true;
}

// Logs the page view.  
// No need to get the actual ratings & comments until 
// commit time when the keyword xml heuristics are generated.
function uzLogKeywordPage(uzInKeyword, addy, title) {
	
	debugDump("Requesting keyword log from " + uzInKeyword + "\n");
}


function uzToggleMode(uzCurMode) {
	// Toggle uzCurMode;
	/*
	debugDump(">> uzReview: Toggling mode ");// + uzCurMode.getAttribute("id") + "\n");
	// New Mode is keyword
	*/
	if(uzCurMode.getAttribute("id") == "id_keyword") {
		lastmode = "page";
	} else {
		lastmode = "keyword";
	}
	
	if(heuristicsLoggedOnPage) {
		debugDump("switch  mode with hlogged \n");
		logHeuristics();
		heuristicsLoggedOnPage = false;
	}	else {
		debugDump("switch mode with h not logged \n")
	}

	if(uzCurMode.getAttribute("id") == "id_keyword") {
		uzInKeyword = document.getElementById("heuristic_keyword").value;
	} else {
		uzInKeyword = false;
	}
	uzLoadExisting();
}



function uzMonitorKeyword(evt) {
	if(evt.keyCode == 13) {
		if(document.getElementById("heuristic_keyword").value.length) {
			//document.getElementById("id_url").checked = "false";
			//document.getElementById("id_keyword").checked = "true";
			document.getElementById("uzMode").selectedIndex = document.getElementById("id_keyword");
			uzToggleMode(document.getElementById("id_keyword"));
		}
	}
	if(document.getElementById("heuristic_keyword").value.length) {
		document.getElementById("id_keyword").disabled = false;
	} else {
		document.getElementById("id_keyword").disabled = true;	
	}
}

function loadKeywordFromMenu() {
	debugDump("Loading keyword from menulist\n");
	var uzInKeyword = document.getElementById("heuristic_keyword").value;
	if(uzInKeyword.length) {
	xexpression = "//keyword[@id=\"" + keyword + "\"]";
	nodes = xHeuristics.evaluate(xexpression, xHeuristics, null, 0, null);  // Xpath eval
	debugDump(">> uzReview: Pre-existing content for this page/keyword " + nodes + "\n");
	node = nodes.iterateNext();
	debugDump("Got node " + node + "\n");
	if(node) {
		uzLoadExisting()
	}
	} else {
		debugDump("Error: tried to load empty keyword\n");
	}
}

function toggleCommentState(node){
	var rootNode = node.parentNode.parentNode;
	debugDump("toggling state " + rootNode.getAttribute("id") + " open " + node.getAttribute("open") + " built " + node.getAttribute("built") + "\n");
	if(node.getAttribute("open")=="false") {
		if(node.getAttribute("built")=="false") {
			debugDump("adding comment block\n");
			makeCommentBlock(node.parentNode.parentNode);
			node.setAttribute("built", "true");
		} else {
			rootNode.childNodes.item(rootNode.childNodes.length-1).hidden="false";
		}
		node.setAttribute("open", "true");
		
		node.setAttribute("src", "chrome://uzreview/content/skin/arrowdown.png");
	} else {
		node.setAttribute("src", "chrome://uzreview/content/skin/arrowright.png");
		rootNode.childNodes.item(rootNode.childNodes.length-1).hidden="true";
		rootNode.childNodes.item(rootNode.childNodes.length-1).setAttribute("open", "false");
	}
}